;
;  DEMO.ASM
;  demonstrate using Metalink CROSS ASSEMBLER
;  Copyright (C) 1999 W.SIRICHOTE
;
;  Primary controls
$MOD51
;$TITLE(BYTE SIGNED MULTIPLY)
;$PAGEWIDTH(132)
;$DEBUG
$OBJECT
;$NOPAGING
;
;
;  Variable declarations
;
sign_flag	BIT	0F0H		;sign of product
multiplier	DATA	030H		;8-bit multiplier
multiplicand	DATA	031H		;8-bit multiplicand
product_high	DATA	032H		;high byte of 16-bit answer
product_low	DATA	033H		;low byte of answer
;
;
;
  ORG 8000H      ;C-52 RAM space
;
byte_signed_multiply:
		CLR	sign_flag	;reset sign
		MOV	A,multiplier	;put multiplier in accumulator
		JNB	ACC.7,positive	;test sign bit of multiplier
		CPL	A		;negative--complement and
		INC	A		;add 1 to convert to positive
		SETB	sign_flag	;and set sign flag
;
positive:	MOV	B,multiplicand	;put multiplicand in B register
		JNB	B.7,multiply	;test sign bit of multiplicand
		XRL	B,#0FFh		;negative--complement and
		INC	B		;add 1 to convert to positive
		CPL	sign_flag	;complement sign flag
;
multiply:	MUL	AB		;do unsigned multiplication
;
sign_test:	JNB	sign_flag,byte_signed_exit	;if positive,done
		XRL	B,#0FFh		;else have to complement both
		CPL	A		;bytes of the product and inc
		ADD	A,#1		;need add here because inc doesn't set
		JNC	byte_signed_exit	;the carry flag
		INC	B		;if add overflowed A, inc the high byte
;
byte_signed_exit:
		MOV	product_high,B	;save the answer
		MOV	product_low,A	
;
		RET			;and return
	END
