;
;  DEMO.ASM
;  Demonstration of using Metalink CROSS ASSEMBLER
;  Copyright (C) 1999 W.SIRICHOTE
;  14 Feb 1999
;  25 July 1999 modified for myPAULMON2

;  Primary controls
$MOD52   ; 8052 predefined
$INCLUDE(myPAULM2.EQU) ; address of PAULMON2 utility routines
$LIST    ; overrided by $NOPRINT
$NOPRINT ; to see error on screen, if any errors found

EOS      EQU  0
tock     equ  10

        DSEG  AT 30H  ; internal RAM space
BCD1:    DS  1
BCD2:    DS  2
cputick: ds  1
temp:    ds  1
count:   ds  2

        CSEG  AT 8000h ; our C-52 EVB start address of code space
        jmp  start

        org   800Bh    ; interrupt vector has moved to here
        jmp  service_timer0


start:  mov  sp,#60h
        orl  TMOD,#00000001b
       ; SETB IE.7       ;  set bit  EA
       ; SETB IE.1       ;  set bit  ET0 Enable timer 0 interrupt
        mov  cputick,#0
        mov  temp,#0
        mov  count,#0
        mov  count+1,#0
        SETB TCON.4    ;  start timer 0

        CALL main      ;  Execute program
        jmp  monitor   ; return to monitor


main:   ;mov  a,cputick
        ;cjne a,#tock,main
        jnb  tf0,$     ; while(TF0 ==0);
        clr  tf0       ; clear TF0
        mov  th0,#0dch  ; reload timer 0
        mov  tl0,#0
        inc  cputick
        mov  a,cputick
        cjne a,#tock,main

        mov  cputick,#0
        cpl  p1.0
        mov  dptr,#title
        call pstr
        inc  temp
        mov  a,temp
        call pint8u
        mov  a,#' '
        call cout
        mov  dpl,count
        mov  dph,count+1
        inc  dptr
        mov  count,dpl
        mov  count+1,dph
        call pint16u
        call newline
        cpl  p1.7
        mov  a,count
        cjne a,#10,main
        setb c
        ret



        DSEG

RESULT: DS  2

        CSEG

service_timer0:
   MOV  TH0,#0DCh     ; reload timer 0 for 10 ms
   MOV  TL0,#0
   INC  cputick
   RETI

TITLE:  DB ' Hello world',32,EOS

        end
